<?php if (!defined('VSF_BLOCK_DIR')) die("Denied");

	include_once('pagination.php');
	
	/* Sets up the tables and admin page */
	class BlockSetupAdmin
	{
		private static $ipRegExp = "/^(?:(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.){3}(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$/";
		private static $REPLACE_COL = "[REPLACE_COL]";
		private static $REPLACE_VALUE = "[REPLACE_VALUE]";
		private static $VIEW_FILTER_RULES = "filterRules";
		private static $VIEW_BLOCK_RULES = "blockRules";
		private static $VIEW_BLOCKS = "blocks";
		private static $VIEW_SPIDER_TRAP = "spiderTrap";
		private static $MAX_ITEMS = 100000;
		
		private $filterRuleCurrentPage;
		private $blockRuleCurrentPage;
		private $blockCurrentPage;
		private $spiderTrapCurrentPage;
		
		private $tablePrefix = "";
		
		private $selectedView;
		
		private $maxTableRows = 0;
		
		public function adminOptionsPanel()
		{
			global $wpdb;
			$this->tablePrefix = $wpdb->prefix;
			
			$resetAllPageNumbers = false;
			$this->blockRuleCurrentPage = $_GET[blockRule];
			$this->filterRuleCurrentPage = $_GET[filterRule];
			$this->blockCurrentPage = $_GET[block];
			
			if ( !self::isNullOrBlankString($_POST['ruleDelValue']) ) 
			{
				$resetAllPageNumbers = true;
				
				$ruleDelValue = $_POST['ruleDelValue'];
				//echo "ruleDelValue " . $ruleDelValue . "<br />";
				
				mysql_query("DELETE FROM `" . $this->tablePrefix . BlockSetup::$TABLE_RULES . "` WHERE id = $ruleDelValue");
				
				$this->buildUpdateDiv(__('Deleted Block Rule', 'vsf-simple-block'));
			}
			
			if ( !self::isNullOrBlankString($_POST['vsfBlockSelectedView']) )
			{
				$resetAllPageNumbers = true;
				
				$this->selectedView = $_POST['vsfBlockSelectedView'];
			}
			
			if ( self::isNullOrBlankString($this->selectedView) )
			{
				$this->selectedView = self::$VIEW_BLOCKS;
			}
			
			if ( isset($_POST['updateGeneralSettingsSubmit']) )
			{
				$resetAllPageNumbers = true;
				
				$updatedSettings = false;
					
				if ( self::isNullOrBlankString($_POST['bounceAddress']) )
				{
					$this->buildErrorDiv(__('Failed to update bounce address, cannot use blank address', 'vsf-simple-block'));
				}
				else
				{
					$bounceAddress = $_POST['bounceAddress'];
					// clean up the bounce address
					$bounceAddress = self::cleanUpString($bounceAddress, 200);
					// Bounce address
					update_option("vsf_block_bounce_address", $bounceAddress);
					$updatedSettings = true;
				}
				
				if ( self::isNullOrBlankString($_POST['tableItemsQuantity']) )
				{
					update_option("vsf_block_bounce_address", self::$MAX_ITEMS);
					$updatedSettings = true;
				}
				else
				{
					$tableItemsQuantity = $_POST['tableItemsQuantity'];
					if( $tableItemsQuantity >= 10 && $tableItemsQuantity <= self::$MAX_ITEMS )
					{
						update_option("vsf_block_table_items_quantity", $tableItemsQuantity);
						$updatedSettings = true;
					}
					else
					{
						$this->buildErrorDiv(__('Failed to update table row quantity as value was outside range 10 - 100000', 'vsf-simple-block'));
					}
				}
				
				if( $updatedSettings )
				{
					$this->buildUpdateDiv(__('Updated settings', 'vsf-simple-block'));
				}
			}
			
			$this->maxTableRows = get_option("vsf_block_table_items_quantity");
			$this->maxTableRows = $this->maxTableRows == null ? self::$MAX_ITEMS : $this->maxTableRows;
			
			if ( isset($_POST['newBlockRuleSubmit']) )
			{
				$resetAllPageNumbers = true;
				
				$newRuleType = $_POST['newBlockRuleType'];
				$newRule1 = $_POST['newBlockRule1'];
				$newRule2 = $_POST['newBlockRule2'];
				$newRuleDescription = $_POST['newBlockRuleDescription'];
				
				$this->buildAndRunNewRuleInsertStatement(BlockSetup::$TABLE_RULES_RULE_BLOCK, $newRuleType, $newRule1, $newRule2, $newRuleDescription);
			}
			
			if ( isset($_POST['newFilterRuleSubmit']) )
			{
				$resetAllPageNumbers = true;
				
				$newRuleType = $_POST['newFilterRuleType'];
				$newRule1 = $_POST['newFilterRule1'];
				$newRule2 = $_POST['newFilterRule2'];
				$newRuleDescription = $_POST['newFilterRuleDescription'];
				
				$this->buildAndRunNewRuleInsertStatement(BlockSetup::$TABLE_RULES_RULE_FILTER, $newRuleType, $newRule1, $newRule2, $newRuleDescription);
			}
			
			if ( !self::isNullOrBlankString($_POST['clearBlocks']) && $_POST['clearBlocks'] == "1" )
			{
				$resetAllPageNumbers = true;
				
				$result = mysql_query("TRUNCATE TABLE " . $this->tablePrefix . BlockSetup::$TABLE_BLOCK . "");
				if( $result == 1 ) $this->buildUpdateDiv(__('deleted All Block Records', 'vsf-simple-block'));
				else $this->buildErrorDiv(__('An error occured during truncating block table', 'vsf-simple-block'));
			}
			
			if( isset($_POST['vsfBlockImportSettings']) )
			{
				$resetAllPageNumbers = true;
				
				$importFile = $_FILES["vsfBlockImportSettingsFile"];
				
				if ($importFile["error"] > 0)
				{
					$this->buildErrorDiv(__('Error: There was a problem uploading the filter ip file.  Please try again.', 'vsf-simple-block'));
				}
				else
				{
					if( $importFile["type"] != 'text/xml' )
					{
						$this->buildErrorDiv(__('File type is not correct!', 'vsf-simple-block'));
					}
					else if ( ($importFile["size"] / 1024) > 100 )
					{
						$this->buildErrorDiv(__('File size is too large.  File needs to be less than 100kb!', 'vsf-simple-block'));
					}
					else
					{
						$filterIpfileContent = file_get_contents($importFile["tmp_name"]);
						
						include('vsf_simple_block_import.php');
						
						$xmlReaderForSimpleBlock = new VSFSimpleBlockImport();
						$xmlReaderForSimpleBlock->importFileValues($filterIpfileContent);
					}
				}
			}
			
			if( $resetAllPageNumbers )
			{
				$this->filterRuleCurrentPage = NULL;
				$this->blockRuleCurrentPage = NULL;
				$this->blockCurrentPage = NULL;
			}
			
			?>
			<style type="text/css">
				.inside { margin:12px!important; }
			</style>
			<script>
				function downloadSpidertrap()
				{
					document.getElementById('vsfBlockDownloadSpidertrap').value = "download";
					document.getElementById('vsfBlockForm').submit();
				}

				function exportSettings()
				{
					document.getElementById('vsfBlockExportSettings').value = "export";
					document.getElementById('vsfBlockForm').submit();
				}
				
				function resetButtons()
				{
					document.getElementById('vsfBlockDownloadSpidertrap').value = "";
					document.getElementById('vsfBlockExportSettings').value = "";
				}
				
				function delRule(formObject, rule)
				{
					resetButtons();
					formObject.ruleDelValue.value = rule;
					formObject.submit();
				}
				
				function newBlockRuleComboChange(formObject)
				{
					resetButtons();
					//alert("changed " + formObject.newRuleType.value);
					formObject.newBlockRule2.disabled = !(formObject.newBlockRuleType.value == 1);
					formObject.newBlockRule2.style.backgroundColor = (formObject.newBlockRuleType.value == 1 ? "white" : "grey");
				}
				
				function newFilterRuleComboChange(formObject)
				{
					resetButtons();
					//alert("changed " + formObject.newFilterRuleType.value);
					formObject.newFilterRule2.disabled = !(formObject.newFilterRuleType.value == 1);
					formObject.newFilterRule2.style.backgroundColor = (formObject.newFilterRuleType.value == 1 ? "white" : "grey");
				}
				
				function vsfBlockChangeSelectedView(view)
				{
					resetButtons();
					document.getElementById('vsfBlockSelectedView').value = view;
					document.getElementById('vsfBlockForm').submit();
				}
				
				function clearBlockRecords(formObject)
				{
					resetButtons();
					var confirmBox = window.confirm("<?php _e("Are you sure you want to clear the block records?", 'vsf-simple-block'); ?>")
					if (confirmBox)
					{
						formObject.clearBlocks.value = 1;
						formObject.submit();
					}
				}
			</script>
			<div class="wrap">
				<h2><?php _e('Options', 'vsf-simple-block'); ?></h2>
				<form id="vsfBlockForm" method="post" enctype="multipart/form-data">
					<input type="hidden" name="ruleDelValue"><input type="hidden" name="clearBlocks"><input id="vsfBlockSelectedView" type="hidden" name="vsfBlockSelectedView" value="<?php echo $this->selectedView; ?>"><input id="vsfBlockDownloadSpidertrap" type="hidden" name="vsfBlockDownloadSpidertrap" /><input id="vsfBlockExportSettings" type="hidden" name="vsfBlockExportSettings" />
						
					<div id="poststuff" class="metabox-holder has-right-sidebar">
						<div id="side-info-column" class="inner-sidebar">
							<?php $this->buildSideBarContent(); ?>
						</div>
						
						<div id="post-body" class="has-sidebar">
							<div class="has-sidebar-content" id="post-body-content">
								<?php $this->buildMainContent(); ?>
							</div>
						</div>
					</div>
					
				</form>
			</div>
		<?php
		}
		
		private function buildSideBarContent()
		{
			$this->buildAboutPanel();
			$this->buildGeneralSettingsPanel();
			$this->buildImportExportPanel();
		}
		
		private function buildMainContent()
		{
			?><div id="vsfBlockView" class="postbox">
				<h3 class="hndle"><?php _e('View', 'vsf-simple-block'); ?></h3>
				<div class="inside">
					<ul class="subsubsub">
						<li><a <?php if( $this->selectedView == self::$VIEW_BLOCKS ) echo 'class="current" '; ?>onClick="vsfBlockChangeSelectedView('<?php echo self::$VIEW_BLOCKS ?>')"><?php _e('Block Records', 'vsf-simple-block'); ?></a> |</li>
						<li><a <?php if( $this->selectedView == self::$VIEW_FILTER_RULES ) echo 'class="current" '; ?>onClick="vsfBlockChangeSelectedView('<?php echo self::$VIEW_FILTER_RULES ?>')"><?php _e('Filter Rules', 'vsf-simple-block'); ?></a> |</li>
						<li><a <?php if( $this->selectedView == self::$VIEW_BLOCK_RULES ) echo 'class="current" '; ?>onClick="vsfBlockChangeSelectedView('<?php echo self::$VIEW_BLOCK_RULES ?>')"><?php _e('Block Rules', 'vsf-simple-block'); ?></a> |</li>
						<li><a <?php if( $this->selectedView == self::$VIEW_SPIDER_TRAP ) echo 'class="current" '; ?>onClick="vsfBlockChangeSelectedView('<?php echo self::$VIEW_SPIDER_TRAP ?>')"><?php _e('Spider Trap', 'vsf-simple-block'); ?></a></li>
					</ul>
				</div>
				<p>&#160;</p><p>&#160;</p>
			</div><?php
			
			if ( $this->selectedView == self::$VIEW_FILTER_RULES ) $this->buildBlockFilterPanel();
			else if ( $this->selectedView == self::$VIEW_BLOCK_RULES ) $this->buildBlockRulesPanel();
			else if ( $this->selectedView == self::$VIEW_BLOCKS ) $this->buildBlockedEntriesPanel();
			else if ( $this->selectedView == self::$VIEW_SPIDER_TRAP ) $this->buildSpiderTrapPanel();
		}
		
		private function buildAboutPanel()
		{
			?>
			<div id="vsfBlockAbout" class="postbox">
				<h3 class="hndle"><?php _e('About VSF Simple Block', 'vsf-simple-block'); ?></h3>
				<div class="inside">
					<ul>
						<li><a href="http://blog.v-s-f.co.uk/simple-block/?simple-block-admin" target="_blank">VSF Simple Block - Home Page</a></li>
						<li><a href="http://wordpress.org/extend/plugins/vsf-simple-block/" target="_blank">VSF Simple Block - Wordpress Page</a></li>
						<li><?php _e('Please rate whether this plug-in works on the WordPress website to help others make an informed decision', 'vsf-simple-block'); ?></li>
						<li><a href="http://www.amazon.co.uk/wishlist/2FRM957UJWLZ2" target="_blank">VSF Simple Block - Donate</a></li>
						<li>Other Plugins</li>
						<li><a href="http://blog.v-s-f.co.uk/simple-stats/?simple-block-admin" target="_blank">VSF Simple Stats - Home Page</a></li>
					</ul>
				</div>
			</div>
			<?php
		}
		
		private function buildGeneralSettingsPanel()
		{
			?>
			<div id="vsfBlockGeneralSettings" class="postbox">
				<h3 class="hndle"><?php _e('General Settings', 'vsf-simple-block'); ?></h3>
				<div class="inside">
					<?php _e('Bounce address'); ?><br />
					<?php _e('E.g. http://www.google.com'); ?><br />
					<input type="text" name="bounceAddress" value="<?php form_option('vsf_block_bounce_address'); ?>" size="35"><br />
					<p>&#160;</p>
					<?php _e('Auto block Enabled:', 'vsf-simple-block'); ?> <input type="checkbox" disabled="disabled" /><br />
					<br />
					<?php _e('Max number of hits in', 'vsf-simple-block'); ?><br />
					<?php _e('1 minute', 'vsf-simple-block'); ?> <input type="text" name="oneMinute" value="<?php form_option('vsf_block_max_hits_in_one_minute'); ?>" size="3" disabled="disabled"><br />
					<?php _e('2 minutes', 'vsf-simple-block'); ?> <input type="text" name="twoMinute" value="<?php form_option('vsf_block_max_hits_in_two_minute'); ?>" size="3" disabled="disabled"><br />
					<?php _e('5 minutes', 'vsf-simple-block'); ?> <input type="text" name="fiveMinute" value="<?php form_option('vsf_block_max_hits_in_five_minute'); ?>" size="3" disabled="disabled">
					<p>&#160;</p>
					<?php _e('Show', 'vsf-simple-block'); ?> <input type="text" name="tableItemsQuantity" value="<?php form_option('vsf_block_table_items_quantity'); ?>" size="3"> <?php _e('items in table', 'vsf-simple-block'); ?>
					<p>&#160;</p>
					<input type="submit" name="updateGeneralSettingsSubmit" value="<?php _e('Update General Settings', 'vsf-simple-block'); ?>" />
				</div>
			</div>				
			<?php
		}
		
		private function buildImportExportPanel()
		{
			?>
			<div id="vsfBlockImportExport" class="postbox">
				<h3 class="hndle"><?php _e('Import and Export Settings', 'vsf-simple-block'); ?></h3>
				<div class="inside">
					<input type="button" onClick="exportSettings()" value="<?php _e('Export Settings', 'vsf-simple-block'); ?>" /><br />
					<br />
					<input type="file" name="vsfBlockImportSettingsFile" id="file" /><input type="submit" name="vsfBlockImportSettings" value="<?php _e('Import Settings', 'vsf-simple-block'); ?>" />
				</div>
			</div>				
			<?php
		}
		
		private function buildBlockFilterPanel()
		{
			?><div id="vsfBlockGeneralSettings" class="postbox">
				<h3 class="hndle"><?php _e('Filter Rules', 'vsf-simple-block'); ?></h3>
				<div class="inside">
					<p><?php _e('This table contains a list of filters that each hit on the website will be checked against.  If the hit is matched to a filter, then the hit will allowed through without any further checks.  If a match is not found it will be checked against the rules and block records and if matched will be bounced.', 'vsf-simple-block'); ?></p>
					<p><?php _e('Values placed in this table are checked *before* the rules and block table so it\'s important to think abou the ordering.  If there\'s a block rule like browser summary containing "www" and a block filter containing "www.google.com" and the hit browser summary is "www.google.com" it will be filtered and not blocked as the filter will be applied first.'); ?></p>
					<p></p>
					<table width="100%">
						<tr valign="top">
							<td><?php _e('Type', 'vsf-simple-block'); ?></td>
							<td><?php _e('Value', 'vsf-simple-block'); ?></td>
							<td><?php _e('IP to (Range)', 'vsf-simple-block'); ?></td>
							<td><?php _e('Description', 'vsf-simple-block'); ?></td>
							<td></td>
						</tr>
						<tr valign="top">
							<td><select id="newFilterRuleType" name="newFilterRuleType" onChange="newFilterRuleComboChange(this.form)"><option value="1" selected><?php _e('IP Address', 'vsf-simple-block'); ?></option><option value="2"><?php _e('Host Address', 'vsf-simple-block'); ?></option><option value="3"><?php _e('Browser Summary', 'vsf-simple-block'); ?></option></select></td>
							<td><input type="text" name="newFilterRule1"></td>
							<td><input id="newFilterRule2" type="text" name="newFilterRule2"></td>
							<td><input type="text" name="newFilterRuleDescription"></td>
							<td><input type="submit" name="newFilterRuleSubmit" value="<?php _e('Add New Filter Rule', 'vsf-simple-block'); ?>" /></td>
						</tr>
					</table>
					<div class="tablenav">
						<div class='tablenav-pages'>
							<?php
								$fields = array("id", BlockSetup::$TABLE_RULES_TYPE, BlockSetup::$TABLE_RULES_HOST, "INET_NTOA(" . BlockSetup::$TABLE_RULES_IP1 . ")", "INET_NTOA(" . BlockSetup::$TABLE_RULES_IP2 . ")", BlockSetup::$TABLE_RULES_BROWSER_KEYWORD, description);
								$table = $this->tablePrefix . BlockSetup::$TABLE_RULES;
								$where = BlockSetup::$TABLE_RULES_RULE . " = " . BlockSetup::$TABLE_RULES_RULE_FILTER;
								$order = "id desc"; // Most recent first
								
								$selectQuery = $this->buildSelectQuery(false, $fields, $table, $where, $order);
								
								$countQuery = $this->buildSelectQuery(true, null, $table, $where, null);
								$items = mysql_fetch_row(mysql_query($countQuery)); // number of total rows in the database
								
								VSFBlockEssentials::log("number of items found " . $items[0] . "" . ($items[0] > 0));
								
								if( $items[0] > 0 )
								{
									$pagingForBotLookup = new pagination;
									$pagingForBotLookup->items($items[0]);
									$pagingForBotLookup->limit($this->maxTableRows); // Limit entries per page
									$pagingForBotLookup->target("?page=vsf_simple_block_setup.php");
									$pagingForBotLookup->parameterName("filterRule");
									$pagingForBotLookup->currentPage(($this->filterRuleCurrentPage > 0 ? $this->filterRuleCurrentPage : 1)); // Gets and validates the current page

									//Query for limit paging
									$lowerLimit = (($pagingForBotLookup->page - 1) * $pagingForBotLookup->limit);
									$selectQuery .= " LIMIT " . ($lowerLimit >= 0 ? $lowerLimit : 0) . ", " . $pagingForBotLookup->limit;
									VSFBlockEssentials::log("before show pagination");
									
									// Doesn't show anything if there is only 1 page... took me some time to work this out...
									echo $pagingForBotLookup->show();  // Echo out the list of paging.
									VSFBlockEssentials::log("after show pagination");
								}
							?>
						</div>
					</div>
				
					<table cellspacing="0" class="widefat fixed">
						<?php
							$columns = array(
								__('Remove', 'vsf-simple-block'), 
								__('Host', 'vsf-simple-block'),
								__('IP', 'vsf-simple-block'), 
								__('Browser Summary', 'vsf-simple-block'), 
								__('Description', 'vsf-simple-block')
							);
							$this->buildTableHeadAndFooter($columns);
						?>
						
						<tbody>
							<?php  
							
							$x = 0;
							VSFBlockEssentials::log($selectQuery);
							$botsLookupQueryResult = mysql_query($selectQuery);
							while ( $c = mysql_fetch_row($botsLookupQueryResult) )
							{
								?><tr class="<?php if( ($x % 2) == 0 ) echo "alternate"; ?>">
									<td><input type="button" value="<?php _e('Remove', 'vsf-simple-block'); ?>" onClick="delRule(this.form, '<?php echo $c[0]; ?>');"></td>
									<td><?php echo $c[2]; ?></td>
									<td><?php echo $c[3]; if( !self::isNullOrBlankString($c[4]) ) echo " - " . $c[4]; ?></td>
									<td><?php echo $c[5]; ?></td>
									<td><?php echo $c[6]; ?></td>
								</tr><?php
								
								$x++;
							}
							
							?>
						</tbody>
					</table>
				</div>
			</div><?php
		}
		
		private function buildBlockRulesPanel()
		{
			?>
			<div id="vsfBlockBlockRules" class="postbox">
				<h3 class="hndle"><?php _e('Block Rules', 'vsf-simple-block'); ?></h3>
				<div class="inside">
					<p><?php _e('This table contains a list of rules that each hit on the website will be checked against.  If the hit is matched to a rule, then the hit will be placed in the block table and the hit will be bounced to the address given in the general settings.', 'vsf-simple-block'); ?></p>
					<p><?php _e('Rules are added as either an IP based rule, Host based rule or Browser summary rule.  An IP rule will check hits against all IP\'s added to this table.  IP\'s can be added as an individual IP or a range.  Host based rules look at the values in the table and basically does a contains match.  So if your host is "www.007guard.com" and there is a host rule "www", the hit will be bounced as "www" is contained in the host.  Browser summary rules are very similar to Host rules.  Add in a keyword or pattern for example "mozilla" and all browser summaries that contain that string will be bounced.', 'vsf-simple-block'); ?></p>
					<p><?php _e('All rules will be overridden by values in the Block Filter table.  Also if you have VSF Simple Stats installed, values in the stats filter table will also not be blocked.', 'vsf-simple-block'); ?></p>
					<p><i><?php _e('Be very careful when inserting a new value.  Think about your own IP, Host and Browser summary as if you add a value that matches yourself, the only way to get back in to your site is to manually remove entries from two tables in the database!', 'vsf-simple-block'); ?></i></p>
					<p></p>
					<table width="100%">
						<tr valign="top"><td colspan="2"><b><?php _e('Your details', 'vsf-simple-block'); ?></b></td></tr>
						<tr valign="top"><td><b><?php _e('IP Address', 'vsf-simple-block'); ?></b></td><td><?php echo $_SERVER['REMOTE_ADDR']; ?></td></tr>
						<tr valign="top"><td><b><?php _e('Host Address', 'vsf-simple-block'); ?></b></td><td><?php echo gethostbyaddr($_SERVER['REMOTE_ADDR']); ?></td></tr>
						<tr valign="top"><td><b><?php _e('Browser Summary', 'vsf-simple-block'); ?></b></td><td><?php echo $_SERVER['HTTP_USER_AGENT']; ?></td></tr>
					</table>
					<p></p>
					<table width="100%">
						<tr valign="top">
							<td><?php _e('Type', 'vsf-simple-block'); ?></td>
							<td><?php _e('Value', 'vsf-simple-block'); ?></td>
							<td><?php _e('IP to (Range)', 'vsf-simple-block'); ?></td>
							<td><?php _e('Description', 'vsf-simple-block'); ?></td>
							<td></td>
						</tr>
						<tr valign="top">
							<td><select id="newBlockRuleType" name="newBlockRuleType" onChange="newBlockRuleComboChange(this.form)"><option value="1" selected><?php _e('IP Address', 'vsf-simple-block'); ?></option><option value="2"><?php _e('Host Address', 'vsf-simple-block'); ?></option><option value="3"><?php _e('Browser Summary', 'vsf-simple-block'); ?></option></select></td>
							<td><input type="text" name="newBlockRule1"></td>
							<td><input id="newBlockRule2" type="text" name="newBlockRule2"></td>
							<td><input type="text" name="newBlockRuleDescription"></td>
							<td><input type="submit" name="newBlockRuleSubmit" value="<?php _e('Add New Block Rule', 'vsf-simple-block'); ?>" /></td>
						</tr>
					</table>
					<div class="tablenav">
						<div class='tablenav-pages'>
							<?php
								
								$fields = array("id", BlockSetup::$TABLE_RULES_TYPE, BlockSetup::$TABLE_RULES_HOST, "INET_NTOA(" . BlockSetup::$TABLE_RULES_IP1 . ")", "INET_NTOA(" . BlockSetup::$TABLE_RULES_IP2 . ")", BlockSetup::$TABLE_RULES_BROWSER_KEYWORD, description);
								$table = $this->tablePrefix . BlockSetup::$TABLE_RULES;
								$where = "(" . BlockSetup::$TABLE_RULES_RULE . " = " . BlockSetup::$TABLE_RULES_RULE_BLOCK . ") or (" . BlockSetup::$TABLE_RULES_RULE . " = " . BlockSetup::$TABLE_RULES_RULE_EXACT_BLOCK . ")";
								$order = "id desc"; // Most recent first
								
								$selectQuery = $this->buildSelectQuery(false, $fields, $table, $where, $order);
								
								$countQuery = $this->buildSelectQuery(true, null, $table, $where, null);
								$items = mysql_fetch_row(mysql_query($countQuery)); // number of total rows in the database
								VSFBlockEssentials::log("number of items found .." . $items[0] . ".." . ($items[0] > 0));
								
								if( $items[0] > 0 )
								{
									$pagingForBotLookup = new pagination;
									$pagingForBotLookup->items($items[0]);
									$pagingForBotLookup->limit($this->maxTableRows); // Limit entries per page
									$pagingForBotLookup->target("?page=vsf_simple_block_setup.php");
									$pagingForBotLookup->parameterName("blockRule");
									$pagingForBotLookup->currentPage(($this->blockRuleCurrentPage > 0 ? $this->blockRuleCurrentPage : 1)); // Gets and validates the current page

									//Query for limit paging
									$lowerLimit = (($pagingForBotLookup->page - 1) * $pagingForBotLookup->limit);
									$selectQuery .= " LIMIT " . ($lowerLimit >= 0 ? $lowerLimit : 0) . ", " . $pagingForBotLookup->limit;
									VSFBlockEssentials::log("before show pagination");
									
									// Doesn't show anything if there is only 1 page... took me some time to work this out...
									echo $pagingForBotLookup->show();  // Echo out the list of paging.
									VSFBlockEssentials::log("after show pagination");
								}
							?>
						</div>
					</div>
				
					<table cellspacing="0" class="widefat fixed">
						<?php
							$columns = array(
								__('Remove', 'vsf-simple-block'), 
								__('Host', 'vsf-simple-block'),
								__('IP', 'vsf-simple-block'), 
								__('Browser Summary', 'vsf-simple-block'), 
								__('Description', 'vsf-simple-block')
							);
							$this->buildTableHeadAndFooter($columns);
						?>
						
						<tbody>
							<?php  
							
							$x = 0;
							VSFBlockEssentials::log($selectQuery);
							$botsLookupQueryResult = mysql_query($selectQuery);
							while ( $c = mysql_fetch_row($botsLookupQueryResult) )
							{
								?><tr class="<?php if( ($x % 2) == 0 ) echo "alternate"; ?>">
									<td><input type="button" value="<?php _e('Remove', 'vsf-simple-block'); ?>" onClick="delRule(this.form, '<?php echo $c[0]; ?>');"></td>
									<td><?php echo $c[2]; ?></td>
									<td><?php echo $c[3]; if( !self::isNullOrBlankString($c[4]) ) echo " - " . $c[4]; ?></td>
									<td><?php echo $c[5]; ?></td>
									<td><?php echo $c[6]; ?></td>
								</tr><?php
								
								$x++;
							}
							
							?>
						</tbody>
					</table>
					
				</div>
			</div>
			
			<?php
		}
		
		private function buildBlockedEntriesPanel()
		{
			?>
			
			<div id="vsfBlockEntries" class="postbox">
				<h3 class="hndle"><?php _e('Blocks', 'vsf-simple-block'); ?></h3>
				<div class="inside">
					<p><?php _e('This table contains a list of hits that have been blocked.  After 500 records, the last record will be deleted when a new record is added.', 'vsf-simple-block'); ?></p>
					<p><input type="button" name="clearAllBlockRecords" value="<?php _e('Clear All Block Records', 'vsf-simple-block'); ?>" onClick="clearBlockRecords(this.form)"></p>
					
					<div class="tablenav">
						<div class='tablenav-pages'>
							<?php
								$fields = array(BlockSetup::$TABLE_BLOCK_DATE_BLOCKED, "INET_NTOA(" . BlockSetup::$TABLE_BLOCK_IP . ")", BlockSetup::$TABLE_BLOCK_HOST, BlockSetup::$TABLE_BLOCK_BROWSER_SUMMARY, BlockSetup::$TABLE_BLOCK_DESCRIPTION);
								$table = $this->tablePrefix . BlockSetup::$TABLE_BLOCK;
								$order = BlockSetup::$TABLE_BLOCK_DATE_BLOCKED . " desc"; // most recent first
								
								$selectQuery = $this->buildSelectQuery(false, $fields, $table, null, $order);
								
								$countQuery = $this->buildSelectQuery(true, null, $table, $where, null);
								$items = mysql_fetch_row(mysql_query($countQuery)); // number of total rows in the database
								VSFBlockEssentials::log("number of items found " . $items[0] . "" . ($items[0] > 0));
								
								if( $items[0] > 0 )
								{
									$pagingForBlocks = new pagination;
									$pagingForBlocks->items($items[0]);
									$pagingForBlocks->limit($this->maxTableRows); // Limit entries per page
									$pagingForBlocks->target("?page=vsf_simple_block_setup.php");
									$pagingForBlocks->parameterName("block");
									$pagingForBlocks->currentPage(($this->blockCurrentPage > 0 ? $this->blockCurrentPage : 1)); // Gets and validates the current page

									//Query for limit paging
									$lowerLimit = (($pagingForBlocks->page - 1) * $pagingForBlocks->limit);
									$selectQuery .= " LIMIT " . ($lowerLimit >= 0 ? $lowerLimit : 0) . ", " . $pagingForBlocks->limit;
									VSFBlockEssentials::log("before show pagination");
									
									// Doesn't show anything if there is only 1 page... took me some time to work this out...
									echo $pagingForBlocks->show();  // Echo out the list of paging.
									VSFBlockEssentials::log("after show pagination");
								}
							?>
						</div>
					</div>
				
					<table cellspacing="0" class="widefat tag fixed">
						<?php
							$columns = array(
								__('Date Blocked', 'vsf-simple-block'), 
								__('IP Address', 'vsf-simple-block'),
								__('Host', 'vsf-simple-block'), 
								__('Browser Summary', 'vsf-simple-block'), 
								__('Description', 'vsf-simple-block')
							);
							$this->buildTableHeadAndFooter($columns);
						?>
						
						<tbody class="list:tag" id="the-list">
							<?php  
							
							$dateFormatForBlock = __('H:i d-m-Y', 'vsf-simple-block');
							
							$x = 0;
							VSFBlockEssentials::log($selectQuery);
							$blockQueryResult = mysql_query($selectQuery);
							while ( $c = mysql_fetch_row($blockQueryResult) )
							{
								?>
									<tr id="<?php echo $c[0]; ?>" class="<?php if( ($x % 2) == 0 ) {echo "alternate";} else {echo "";} ?>">
										<td class="name column-name"><?php echo date($dateFormatForBlock, $c[0]); ?></td>
										<td class="name column-name"><?php echo $c[1]; ?></td>
										<td class="name column-name"><?php echo $c[2]; ?></td>
										<td class="name column-name"><?php echo $c[3]; ?></td>
										<td class="name column-name"><?php echo $c[4]; ?></td>
									</tr>
								<?php
								
								$x++;
							}
							
							?>
						</tbody>
					</table>
					
				</div>
			</div>
			
			<?php
		}
		
	private function buildSpiderTrapPanel()
		{
			?>
			<div id="vsfSpiderTrapPanel" class="postbox">
				<h3 class="hndle"><?php _e('Spider Trap', 'vsf-simple-block'); ?></h3>
				<div class="inside">
					<h3><?php _e('What is a rougue spider?', 'vsf-simple-block'); ?></h3>
					<p><?php _e('If you\'re using any plugin that shows you exactly who is visiting your site (for example vsf-simpe-stats), you will have noticed the vast number of spiders that come to your site.  
								 Arguably the most famous of them all is the Google Bot.  A lot of them are there to provide a useful service - indexing your site to help others find it when 
								 making a search on a search engine.  But others are not.  Examples are ones that scrape your site of it\'s content, ones that use up bandwidth or ones 
								 that "search" your site at the speed of light (they should be fairly slow so as not to overwhelm your site).  Which spiders are legitimate is entirely
								 up to you, but my pet hates are (in no particular order):', 'vsf-simple-block'); ?></p>
					<p>wasalive<br />CCBot<br />Nutch<br />Deepnet Explorer<br />spreadia<br />Speedy Spider<br />(the list goes on - and on...)<br /></p>
					
					<h3><?php _e('So, how do I stop rogue spiders?', 'vsf-simple-block'); ?></h3>
					<p><?php _e('Well, since you\'ve downloaded this plugin, you\'re part way there already.  You could add keywords to the block table for every spider you don\'t like,
								but you can also do the following:', 'vsf-simple-block'); ?></p>
					
					
					<h4>1. <?php _e('Add a robots.txt file to your site', 'vsf-simple-block'); ?></h4>
					<p><?php _e('If you haven\'t already got a robots.txt file, create one!  Otherwise, edit your existing file to add a disallow path for /spidertrap.php and /spidertrap.html', 'vsf-simple-block'); ?><br />
					<?php _e('If you\'re creating a file for the first time, add the following into the file:', 'vsf-simple-block'); ?><br />
					<b># /robots.txt</b><br />
					<b>User-agent: *</b><br />
					<b>Disallow: /spidertrap.php</b><br />
					<b>Disallow: /spidertrap.html</b><br />
					<?php _e('The above tells all spiders with any user agent to not go to the file spidertrap.php.  Any spiders that disobey that command, I class as ones that are not 
							  wanted on my site.  Save the file and upload it to the root of your web space.', 'vsf-simple-block'); ?></p>
					<p><?php _e('I suggest you now wait an hour before proceeding with the next part.  That will give the spiders a chance to read the robots.txt file and process the command.', 'vsf-simple-block'); ?></p>
					
					
					<h4>2. <?php _e('Add a spider trap link to your template', 'vsf-simple-block'); ?></h4>
					<p><?php _e('Now you will need to place the below link somewhere on the main template page that will act as bait to rogue spiders.  The following link has javascript to 
							  prevent users from being able to click on the link, but not spiders.  Ideally this should be placed as high up the page as possible, but that might not be 
							  possible (like in my case, where it\'s in the footer of my site).', 'vsf-simple-block'); ?></p>
					<p>
						&lt;!-- spider trap --&gt;<br />
							&lt;a href="/spidertrap.php" onclick="return false;" onmouseover="window.status='Do not follow this link, or you will be blocked from this site. This is a spider trap.'; return true;"&gt;<br />
								&lt;font color="white" size="-2"&gt;.&lt;/font&gt;<br />
							&lt;/a&gt;<br />
						&lt;!-- end spider trap --&gt;
					</p>
					
					
					<h4>3. <?php _e('Add the spider trap page to your site', 'vsf-simple-block'); ?></h4>
					<p><?php _e('This is the last part, add a page which will auto block all users who found their way to spidertrap.php.', 'vsf-simple-block'); ?></p>
					<p><?php _e('You can either find the spider.php file inside the vsf-simple-block folder or click the button below to generate one.  If you use the one from the vsf-simple-block
							  folder, you will need to manually edit the database parameters - clicking the below button will do that for you.  Save the file and then upload it to the root of your
							  web space.  Now just wait.  Any spiders which find their way onto spidertrap.php will be blocked and a record will appear in the block records table.', 'vsf-simple-block'); ?></p>
					<p><input type="button" onClick="downloadSpidertrap()" value="Download spidertrap.php file" /></p>


					<p></p>
					<h3><?php _e('References', 'vsf-simple-block'); ?></h3>
					<p><a href="http://www.forumpostersunion.com/forumdisplay.php?s=71969227db92d485543185943f3a4b7a&f=167"><?php _e('Spiders, Crawlers and web robots forum', 'vsf-simple-block'); ?></a><br />
						<a href="http://www.leekillough.com/robots.html?vsf"><?php _e('How to Defeat Bad Web Robots With Apache', 'vsf-simple-block'); ?></a></p>
					
				</div>
			</div>
			
			<?php
		}
		
		/**
		 * Builds up the table header and footer for tables.
		 */
		function buildTableHeadAndFooter($columns)
		{
			?>
			<thead><tr><?php foreach( $columns as $column ) { $this->buildTableHeadingColum($column); } ?></tr></thead>
			<tfoot><tr><?php foreach( $columns as $column ) { $this->buildTableHeadingColum($column); } ?></tr></tfoot>
			<?php
		}
		
		/**
		 * Builds up a column heading/footing for a table.
		 */
		function buildTableHeadingColum($columnTitle)
		{
			?><th class="manage-column" scope="col"><?php echo $columnTitle; ?></th><?php
		}
		
		private static function cleanUpString($stringToClean, $maxLength)
		{
			if( $stringToClean != null && stringToClean != "" )
			{
				$stringToClean = (strlen($stringToClean) <= $maxLength ? $stringToClean : substr($stringToClean, 0, $maxLength));
				$stringToClean = (phpversion() >= '4.3.0' ? mysql_real_escape_string($stringToClean) : mysql_escape_string($stringToClean));
				$stringToClean = str_replace(array('<', '>'), '', $stringToClean);
			}
			
			return $stringToClean;
		}
		
		/**
		 *	Determines whether a string is null or blank.  Returns true if it is else false.
		 */
		private static function isNullOrBlankString($stringToCheck)
		{
			return !((isset($stringToCheck)) && ($stringToCheck != null) && ($stringToCheck != ""));
		}
		
		/**
		 *	Builds a div for showing update messages
		 */
		private function buildUpdateDiv($message) { $this->buildMessageDiv(false, $message); }
		
		/**
		 *	Builds a div for showing warning messages
		 */
		private function buildErrorDiv($message) { $this->buildMessageDiv(true, $message); }
		
		private function buildMessageDiv($error, $message) { ?><div class="<?php if( $error ) echo 'error'; else echo 'updated'; ?>"><p><strong><?php echo $message; ?></strong></p></div><?php }
		
		private function buildAndRunNewRuleInsertStatement($newRuleRule, $newRuleType, $newRule1, $newRule2, $newRuleDescription)
		{
			$newRuleDescription = self::cleanUpString($newRuleDescription, BlockSetup::$TABLE_RULES_DESCRIPTION_MAX_LENGTH);
			
			if( !self::isNullOrBlankString($newRuleType) && !self::isNullOrBlankString($newRule1) )
			{
				$query = "INSERT INTO " . $this->tablePrefix . BlockSetup::$TABLE_RULES . " (" . BlockSetup::$TABLE_RULES_RULE . ", " . BlockSetup::$TABLE_RULES_TYPE . ", " . BlockSetup::$TABLE_RULES_DESCRIPTION . ", " . self::$REPLACE_COL . ") values ($newRuleRule, $newRuleType, " . (self::isNullOrBlankString($newRuleDescription) ? 'null' : '\'' . $newRuleDescription . '\'') . ", " . self::$REPLACE_VALUE . ")";
				
				if( $newRuleType == 1 ) // IP
				{
					if ( !preg_match(self::$ipRegExp, $newRule1) ) self::buildErrorDiv(__('Invalid IP!', 'vsf-simple-block'));
					else if( (($newRule2 != null) && ($newRule2 != "") && !preg_match(self::$ipRegExp, $newRule2)) ) self::buildErrorDiv(__('Invalid IP!', 'vsf-simple-block'));
					else
					{
						$query = str_replace(self::$REPLACE_COL, BlockSetup::$TABLE_RULES_IP1 . ", " . BlockSetup::$TABLE_RULES_IP2, $query);
						$replaceValue = "INET_ATON('$newRule1'), " . ((($newRule2 != null) && ($newRule2 != "")) ? "INET_ATON('$newRule2')" : "null");
						$query = str_replace(self::$REPLACE_VALUE, $replaceValue, $query);
						
						VSFBlockEssentials::log("query is: " . $query);
						$result = mysql_query($query);
					
						if( $result == 1 ) $this->buildUpdateDiv(__('Added New Rule', 'vsf-simple-block'));
						else $this->buildErrorDiv(__('Error occured during browser summary rule insert: ', 'vsf-simple-block') . mysql_error());
					}
				}
				else if( ($newRuleType == 2) || ($newRuleType == 3) ) // Host or browser summary
				{
					$columnValue = "";
					if( $newRuleType == 2 ) // host
					{
						$newRule1 = self::cleanUpString($newRule1, BlockSetup::$TABLE_RULES_HOST_MAX_LENGTH);
						$columnValue = BlockSetup::$TABLE_RULES_HOST;
					}
					else // browser
					{
						$newRule1 = self::cleanUpString($newRule1, BlockSetup::$TABLE_RULES_BROWSER_KEYWORD_MAX_LENGTH);
						$columnValue = BlockSetup::$TABLE_RULES_BROWSER_KEYWORD;
					}
					
					$query = str_replace(self::$REPLACE_COL, $columnValue, $query);
					$query = str_replace(self::$REPLACE_VALUE, '\'' . $newRule1 . '\'', $query);
					
					VSFBlockEssentials::log("query is: " . $query);
					$result = mysql_query($query);
					
					if( $result == 1 ) $this->buildUpdateDiv(__('Added New Rule', 'vsf-simple-block'));
					else $this->buildErrorDiv(__('Error occured during browser summary rule insert: ', 'vsf-simple-block') . mysql_error());
				}
			}
		}
		
		/**
		 *	Builds up a select query using the passed in parameters.
		 */
		private function buildSelectQuery($count, $columns, $table, $where, $order)
		{
			$query = "SELECT ";
			
			if( $count )
			{
				$query .= "count(*) ";
			}
			else
			{
				$x = 0;
				foreach ( $columns as $column )
				{
					$query .= ($x == 0 ? "" : ", ") . $column;
					$x++;
				}
				
				$query .= " ";
			}
			
			$query .= "FROM " . $table . " ";
			
			if( !self::isNullOrBlankString($where) ) $query .= "WHERE " . $where . " ";
			
			if( !$count && !self::isNullOrBlankString($order) ) $query .= "ORDER BY " . $order;
			
			return $query;
		}
	}

?>